// Solution of the Question 1 of the Final Exam (2005-2006)
// Dr. Feza BUZLUCA   http://www.buzluca.info/oop
#include <iostream>
#include <string>
using namespace std;

class Student {
	string name;
	unsigned short int *grades;
	unsigned int numOfCourses;
public:
	Student(const string &, unsigned int);
	Student(const Student &);
	float average() const;
	virtual bool is_successful() const =0;
	virtual ~Student();
};

Student::Student(const string &n, unsigned int nc): name(n),numOfCourses(nc)
{

	grades = new unsigned short int[numOfCourses];
	if (!grades) throw "Not enough memory!";
	cout << "Enter grades" << endl;
	for (unsigned int i=0; i<numOfCourses; i++){
		cout << "Give " << i+1 << " . grade: ";
		cin >> grades[i];
	}
}

Student::Student(const Student &other)
{
	numOfCourses=other.numOfCourses;
	grades = new unsigned short int[numOfCourses];
	if (!grades) throw "Not enoug memory!";
	for (unsigned int i=0; i<numOfCourses; i++)
		grades[i]=other.grades[i];
}

float Student::average() const
{
	unsigned int sum=0;
	for (unsigned int i=0; i<numOfCourses; i++)
		sum += grades[i];
	return static_cast <float> (sum)/numOfCourses;
}

Student::~Student()
{
   delete [] grades;
}

class UnderGradStudent:public Student {
	unsigned short int age;
public:
	UnderGradStudent(const string &, unsigned int, unsigned short int);
	bool is_successful() const;
};

UnderGradStudent::UnderGradStudent(const string &n, unsigned int nc, unsigned short int a): Student(n,nc), age(a)
{}


bool UnderGradStudent::is_successful() const{

	return average() >=50;
}


class GradStudent : public Student{
	string advisor;
 public:
	GradStudent(const string &, unsigned int, const string &);
	virtual bool is_successful() const;
};

GradStudent::GradStudent(const string &n, unsigned int nc, const string & adv): Student(n,nc), advisor(adv)
{}


bool GradStudent::is_successful() const{

	return average() >=70;
}


int main()
{
	Student * students[3];
	try{
		students[0] = new UnderGradStudent("Ali", 3, 20);
		students[1] = new GradStudent("Aye", 4, "Veli");
		students[2] = new UnderGradStudent("Mehmet", 2, 21);
	}
	catch (const char * ){
		cout << "Memory Full!";
	}
	cout << "Average of the 1st student = " << students[0]->average() << endl;
	cout << "Average of the 2nd student = " << students[1]->average() << endl;
	unsigned int count = 0;
 	for (unsigned int i=0; i<3; i++)
		if ( students[i]->is_successful() ) count++;	
	cout << "There are " << count << " successful students in the array" << endl;
	
	UnderGradStudent ugs1 = UnderGradStudent("Ali", 3, 20);
	UnderGradStudent ugs2 = ugs1;

	GradStudent gs1 = GradStudent("Aye", 4, "Veli");
	GradStudent gs2 = gs1;

	delete students[0];
	delete students[1];
	delete students[2];

}