#include <map>
#include <iostream>
using namespace std;
#include "Phone.h"
#include "PhoneBook.h"
#include "PersonalInformation.h"
#include "Nokia6270.h"
#include "SamsungD600.h"

int main(int argc,char *argv[]){
   string names[]={"Kate Austen", "Jack Shephard", "Sun Kwon"};
   pair<string,unsigned long>  
   kateDigits[]={ pair<string,unsigned long>("gsm",5552341),
                  pair<string,unsigned long>("home",5558372)  },
   jackDigits[]={ pair<string,unsigned long>("gsm",5559873)  },
   sunDigits[]={  pair<string,unsigned long>("gsm",5554348),
                  pair<string,unsigned long>("home",5558182),
                  pair<string,unsigned long>("business",5551574)  };
    
   PersonalInformation 
   myFriends[]={  PersonalInformation(names[0],kateDigits,kateDigits+2) },
   myCollages[]={ PersonalInformation(names[1],jackDigits,jackDigits+1),
                  PersonalInformation(names[2],sunDigits,sunDigits+3) }  ;

  PhoneBook *businessPhoneBook= new PhoneBook(myCollages,myCollages+2);
  PhoneBook *personalPhoneBook= new PhoneBook(myFriends,myFriends+1);
  
  Phone *mobilePhone1= new Nokia6270();     
  Phone *mobilePhone2= new SamsungD600(personalPhoneBook);     

  mobilePhone1->setPhoneBook(businessPhoneBook);
  mobilePhone1->setSpeedDial(1,"Sun"); // uses business phone
  mobilePhone1->setSpeedDial(2,5557936);
  mobilePhone2->setSpeedDial(1,"Kate","gsm");

  mobilePhone1->dial(5552341);
  mobilePhone1->dial("Jack Shephard","gsm");
  mobilePhone2->dial("Kate Austen");  
  mobilePhone2->dial("speed-dial",1); // Kate's mobile phone is now ringing

  delete businessPhoneBook;
  delete personalPhoneBook;

  delete mobilePhone2;
  return 0;
}
